$fn = 30;

module roundedRect(size, radius)
{
	x = size[0]-radius;
	y = size[1]-radius;
   linear_extrude(height=0.1)
	hull()
	{
		// place 4 circles in the corners, with the given radius
		translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
	}
}

module standoffhole() {
	  cylinder(h=5.5,r=2.0/2, center=true);
}

module standoff() {
	  cylinder(h=5.5,r=5/2, center=true);

}

module notstandoff() {
	  cylinder(h=5.5,r=5/2, center=true);
}


module box() {
for (i=[0.0:0.1:8.5])  // change 8.5 to 0.1 for debug
{
  union()
  { 
    translate([i/14,0,i])
    if (i<=0.3) {
      roundedRect([46.75+0.0,93.25+1,13],4.0);  //outside box face piece
    }
    else if (i<=2.0) {
      roundedRect([46.75+0.0,93.25+1,13],4.0);  //outside box face intermediate face
    } 
    else {
	   difference() {
  		 roundedRect([46.75+0.0,93.25+1,13],4.0);  //outside box
  	     roundedRect([46.75+0.0-6.64,93.25+1-6.64,13],2.5);  //inside box  // was 2.64 thick
	   }
    }
  }
}
}



difference() {
  union() {  
    box();
    translate([-31/2-0.7,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([-31/2-1.4,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([-31/2-2.1,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([-31/2-2.8,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([-31/2-3.5,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([-31/2-4.2,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([-31/2,-75/2 -0.2 ,2+5.5/2]) standoff();

    translate([-31/2-4.2,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();
    translate([-31/2-3.5,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();
    translate([-31/2-2.8,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();
    translate([-31/2-2.1,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();
    translate([-31/2-1.4,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();
    translate([-31/2-0.7,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();
    translate([-31/2,+75/2 -0.2 + 0.8,2+5.5/2]) standoff();
      
    translate([+31/2 +0.9 +4.2,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff(); 
    translate([+31/2 +0.9 +3.5,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff(); 
    translate([+31/2 +0.9 +2.8,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff(); 
    translate([+31/2 +0.9 +2.1,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();
    translate([+31/2 +0.9 +1.4,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();  
    translate([+31/2 +0.9 +0.7,+75/2 -0.2 + 0.8,2+5.5/2]) notstandoff();   
    translate([+31/2 +0.9,+75/2 -0.2 + 0.8,2+5.5/2]) standoff();
    
    
    translate([+31/2 +0.9+4.2,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([+31/2 +0.9+3.5,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([+31/2 +0.9+2.8,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([+31/2 +0.9+2.1,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([+31/2 +0.9+1.4,-75/2 -0.2 ,2+5.5/2]) notstandoff();    
    translate([+31/2 +0.9+0.7,-75/2 -0.2 ,2+5.5/2]) notstandoff();
    translate([+31/2 +0.9,-75/2 -0.2 ,2+5.5/2]) standoff();
  }
  union() {  
    cube([27.5,72.5+0.3,5],center=true);  //cutout lcd window
    translate([-31/2,-75/2 -0.2 ,2+5.5/2]) standoffhole();  
    translate([-31/2,+75/2 -0.2 + 0.8,2+5.5/2]) standoffhole();
    translate([+31/2 +0.9,+75/2 -0.2 + 0.8,2+5.5/2]) standoffhole();
    translate([+31/2 +0.9,-75/2 -0.2 ,2+5.5/2]) standoffhole();  
  }
}



// small pivot
translate([0,-91.3/2-2.8/2+2.5/2,13-4]) rotate([0,3.945,0]) cube([6.4,3.3+2.5,6.5],center=true);

// large pivot
translate([0,91.3/2+2.8/2-2.5/2,13-4]) rotate([0,3.945,0]) cube([7.8,3.3+2.5,7.8],center=true);

